-- CREATE DATABASE `libreapps_api`;

GRANT SELECT, INSERT, UPDATE, DELETE ON *.* TO 'libreapps_api'@'localhost' IDENTIFIED BY 'mystrongpassword';
GRANT ALL PRIVILEGES ON *.* TO 'libreapps_api'@'localhost' IDENTIFIED BY 'mystrongpassword' WITH GRANT OPTION;

CREATE TABLE `001` (
  `id` int(11) NOT NULL,
  `data` varchar(16000) NOT NULL,
  `date_add` datetime NOT NULL,
  `date_upd` datetime NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;


CREATE TABLE `auth_application` (
  `id` int(11) NOT NULL,
  `name` varchar(128) NOT NULL,
  `code` varchar(8) NOT NULL,
  `date_add` datetime NOT NULL DEFAULT current_timestamp(),
  `date_upd` datetime NOT NULL DEFAULT current_timestamp()
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;

INSERT INTO `auth_application` (`id`, `name`, `code`, `date_add`, `date_upd`) VALUES
(1, 'Ma nouvelle application', 'MNA', '2023-05-03 10:00:00', '2023-05-03 10:00:00');


CREATE TABLE `auth_device` (
  `id` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `os_name` varchar(128) NOT NULL,
  `user_name` varchar(128) NOT NULL,
  `device_name` varchar(128) NOT NULL,
  `status` varchar(32) NOT NULL DEFAULT 'WAITING',
  `date_add` datetime NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;


CREATE TABLE `auth_licence` (
  `id` int(11) NOT NULL,
  `id_application` int(11) NOT NULL,
  `id_owner` int(11) NOT NULL,
  `name` varchar(128) NOT NULL,
  `capacity` int(11) NOT NULL,
  `nb_use` int(11) NOT NULL,
  `status` varchar(64) NOT NULL,
  `date_add` datetime NOT NULL DEFAULT current_timestamp(),
  `date_upd` datetime NOT NULL DEFAULT current_timestamp()
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;

INSERT INTO `auth_licence` (`id`, `id_application`, `id_owner`, `name`, `capacity`, `nb_use`, `status`, `date_add`, `date_upd`) VALUES
(1, 1, 1, 'MNA-1A-5U-1', 5, 1, 'VALID', '2023-05-03 10:00:00', '2023-05-03 10:00:00');


CREATE TABLE `auth_lic_prf_usr` (
  `id` int(11) NOT NULL,
  `id_licence` int(11) NOT NULL,
  `id_profil` int(11) NOT NULL,
  `id_user` int(11) NOT NULL,
  `date_add` datetime NOT NULL DEFAULT current_timestamp(),
  `dat_upd` datetime NOT NULL DEFAULT current_timestamp()
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;

INSERT INTO `auth_lic_prf_usr` (`id`, `id_licence`, `id_profil`, `id_user`, `date_add`, `dat_upd`) VALUES
(1, 1, 1, 1, '2023-05-03 10:00:00', '2023-05-03 10:00:00');


CREATE TABLE `auth_profil` (
  `id` int(11) NOT NULL,
  `id_application` int(11) NOT NULL,
  `name` varchar(128) NOT NULL,
  `date_add` datetime NOT NULL DEFAULT current_timestamp(),
  `date_upd` datetime NOT NULL DEFAULT current_timestamp()
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;

INSERT INTO `auth_profil` (`id`, `id_application`, `name`, `date_add`, `date_upd`) VALUES
(1, 1, 'ADMIN', '2023-05-03 10:00:00', '2023-05-03 10:00:00'),
(2, 1, 'USER', '2023-05-03 10:00:00', '2023-05-03 10:00:00');


CREATE TABLE `auth_user` (
  `id` int(11) NOT NULL,
  `name` varchar(128) NOT NULL,
  `email` varchar(256) NOT NULL,
  `password` varchar(256) NOT NULL,
  `date_add` datetime NOT NULL DEFAULT current_timestamp(),
  `date_upd` datetime NOT NULL DEFAULT current_timestamp()
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;

INSERT INTO `auth_user` (`id`, `name`, `email`, `password`, `date_add`, `date_upd`) VALUES
(1, 'Administrateur', 'admin@libreapps.org', 'admin', '2023-05-03 10:00:00', '2023-05-03 10:00:00');


CREATE TABLE `cache_date` (
  `id` int(11) NOT NULL,
  `id_device` int(11) NOT NULL,
  `id_obj` int(11) NOT NULL,
  `date_upd` datetime NOT NULL DEFAULT current_timestamp()
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;


CREATE TABLE `cache_del` (
  `id` int(11) NOT NULL,
  `obj` varchar(256) NOT NULL,
  `id_obj` int(11) NOT NULL,
  `date_add` datetime NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;


CREATE TABLE `cache_obj` (
  `id` int(11) NOT NULL,
  `id_licence` int(11) NOT NULL,
  `data` int(11) NOT NULL,
  `obj` varchar(256) NOT NULL,
  `date_add` datetime NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;

INSERT INTO `cache_obj` (`id`, `id_licence`, `data`, `obj`, `date_add`) VALUES
(1, 1, 1, 'product', '2023-05-03 10:00:00');


ALTER TABLE `001`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `auth_application`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `auth_device`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `auth_licence`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `auth_lic_prf_usr`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `auth_profil`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `auth_user`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `cache_date`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `cache_del`
  ADD PRIMARY KEY (`id`);

ALTER TABLE `cache_obj`
  ADD PRIMARY KEY (`id`);


ALTER TABLE `001`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=1;
COMMIT;

ALTER TABLE `auth_application`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=2;

ALTER TABLE `auth_device`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `auth_licence`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=2;

ALTER TABLE `auth_lic_prf_usr`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=2;

ALTER TABLE `auth_profil`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=3;

ALTER TABLE `auth_user`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=2;

ALTER TABLE `cache_date`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `cache_del`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT;

ALTER TABLE `cache_obj`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=1;

