<?php 
require './config.php';

try {
  //connection a la base de donnees
  $pdo_options[PDO::ATTR_ERRMODE] = PDO::ERRMODE_EXCEPTION;
  $bdd = new PDO("mysql:host=".$db_host.";dbname=".$db_name, $db_username, $db_password, $pdo_options);
  $obj = (!empty($_GET['obj']))?$_GET['obj']:null;
  $id = (!empty($_GET['id']))?$_GET['id']:null;
  $idLicence = -1;

  //Validation du token
  if (isset($_SERVER['HTTP_AUTHORIZATION'])) {
    $headers = urldecode(trim($_SERVER["HTTP_AUTHORIZATION"]));
    if (preg_match('/Bearer\s(\S+)/', $headers, $matches)) {
      $tabToken = explode(".", $matches[1]);
      // extracting the signature from the original JWT 
      $recieved_signature = $tabToken[2];
      // concatenating the first two arguments of the $tabToken array, representing the header and the payload
      $recievedHeaderAndPayload = $tabToken[0] . '.' . $tabToken[1];
      //Clé secrète encodée base64
      $secret_key = base64urlEncode($secret_key);
      // creating the Base 64 encoded new signature generated by applying the HMAC method to the concatenated header and payload values
      $resultedsignature = base64urlEncode(hash_hmac('sha256', $recievedHeaderAndPayload, $secret_key, true));
      // Verification de la signature
      if($resultedsignature == $recieved_signature) {
        $payload = base64urlDecode($tabToken[1]);
        $tabPayload = json_decode($payload , true);
        // Verification de l'adresse du serveur du token
        if(isset($tabPayload['iss']) && $tabPayload['iss']==$_SERVER['HTTP_HOST']){
          // Verification de la date de validite du token
          if(isset($tabPayload['exp']) && time() < $tabPayload['exp']){
            // Lecture de l'id de l'utilisateur
            if(isset($tabPayload['sub']) && $tabPayload['sub']>0){
              $idLicence = $tabPayload['sub'];
              if(isset($payloadTab['idd'])){
                $idDevice = $payloadTab['idd'];
              }
            }else{
              echo '{"message": "ERROR"}';
            }
          }else{
            echo '{"message": "TOKEN EXPIRED"}';
          }
        }else{
          echo '{"message": "TOKEN INVALID"}';
        }      
      }else{
        echo '{"message": "ERROR"}';
      }
    }
  }

  if($_SERVER['REQUEST_METHOD']=="POST" && $obj!=null && $obj=="auth"){
    $data = (!empty($_POST['data']))?$_POST['data']:((!empty(file_get_contents('php://input')))?file_get_contents('php://input'):null); 
    if($data!=null){
      $data = urldecode($data);
      $dataTab = json_decode($data , true);
      $email = $dataTab['email'];
      $pwd = $dataTab['password'];
      $sql = "SELECT * FROM ".$db_auth."user WHERE email='".$email."' AND password='".$pwd."'";
      $response = $bdd->query($sql);
      if($response->rowCount()==1){
        $output     = $response->fetchAll(PDO::FETCH_ASSOC);
        $idUser     = $output[0]['id'];      // id de l'utilisateur
        $sqlLicence = "SELECT ln.id_licence, pr.name, li.status FROM ".$db_auth."lic_prf_usr ln, ".$db_auth."application ap, ".$db_auth."licence li, ".
            $db_auth."profil pr WHERE ap.code='".$dataTab['app']."' AND li.id_application=ap.id AND li.id=ln.id_licence AND pr.id=ln.id_profil AND ln.id_user=".$idUser;
        $responseLicence = $bdd->query($sqlLicence);
        if($responseLicence->rowCount()==1){
          $outputLicence = $responseLicence->fetchAll(PDO::FETCH_ASSOC);
          if($outputLicence[0]['status']=="VALID"){
            $idLicence  =  $outputLicence[0]['id_licence'];
            $name       =  $outputLicence[0]['name'];
            $issuedAt   = time();                // l'heure courante en seconde          
            $expire     = $issuedAt + 86400;     // Ajoute 24 H à l'heure courante
            $serverName = $_SERVER['HTTP_HOST']; // Recupere l'url du serveur

            // base64 encodes the payload json
            $encoded_payload = base64urlEncode('{"iat": '.$issuedAt.', "iss": "'.$serverName.'", "exp": '.$expire.', "sub": '.$idLicence.', "usr": '.$idUser.', "scope": "'.$name.'" }');
            // base64 strings are concatenated to one that looks like this
            $header_payload = $encoded_header .'.'. $encoded_payload;
            // Clé secrète encodée en base64
            $secret_key = base64urlEncode($secret_key);
            // Creating the signature, a hash with the s256 algorithm and the secret key. The signature is also base64 encoded.
            $signature = base64urlEncode(hash_hmac('sha256', $header_payload, $secret_key, true));
            // Creating the JWT token by concatenating the signature with the header and payload, that looks like this:
            echo $header_payload .'.'. $signature;
          }else{
            echo '{"message": "INVALID LICENCE"}';
          }
        }else{
          echo '{"message": "ERROR"}';
        }
      }else{
        echo '{"message": "ERROR"}';
      }
    }else{
      echo '{"message": "ERROR"}';
    }
  }elseif($idLicence!=-1 && $obj!=null ){
    //Gestion du type de methode
    switch($_SERVER['REQUEST_METHOD']){
      case "POST":  // creation
        $data = (!empty($_POST['data']))?$_POST['data']:((!empty(file_get_contents('php://input')))?file_get_contents('php://input'):null);
        $data = urldecode($data);
        if($data!= null){
          $sql = 'INSERT INTO `'.sprintf("%03d",get_data($idLicence, $obj, $bdd)).'` (data, date_add, date_upd) VALUES ("'.
            base64_encode($data).'", "'.date("Y-m-d H:i:s", time()).'","'.date("Y-m-d H:i:s", time()).'");';
          $bdd->query($sql);

          // Affiche l'id de l'objet cree
          echo $bdd->lastInsertId();
        }else{
          echo '{"message": "ERROR"}';
        }
        break;
      case "GET":  // Recupere les donnees
        $sql = 'SELECT id, data FROM `'.sprintf("%03d",get_data($idLicence, $obj, $bdd))."`";
        if($id!=null){
          $sql .= ' WHERE id='.$id.';';
        }
        $response = $bdd->query($sql);
        $output = $response->fetchAll(PDO::FETCH_ASSOC);

        //On ajoute l'id des objets
        if($id!=null){
          if($response->rowCount()==1){
            echo '{"id":'.$output[0]['id'].",".substr(base64_decode($output[0]['data']),1);
          }
        }else{
          if($response->rowCount()>0){
            echo "[";
            $cpt=0;
            foreach ($output as &$value) {
              echo (($cpt!=0)?",":"");
              echo '{"id":'.$value['id'].",".substr(base64_decode($value['data']),1);
              $cpt++;
            }
            echo "]";
          }
        }            
        break;
      case "DELETE": //Supprime
        if($id!=null){
          $sql = 'DELETE FROM `'.sprintf("%03d",get_data($idLicence, $obj, $bdd)).'` WHERE id = '.$id.';';
          $bdd->query($sql);
          echo '{"message": "OK"}';
        }else{
          echo '{"message": "ERROR"}';
        }
        break;
      case "PUT": //Met a jour
        if($id!=null){
          //On redirie le fichier dans un tableau
          $_SERVER['REQUEST_METHOD']==="PUT" ? parse_str(file_get_contents('php://input', false , null, 0 , $_SERVER['CONTENT_LENGTH'] ), $_PUT): $_PUT=array(); // PHP 7.0
          //$_SERVER['REQUEST_METHOD']==="PUT" ? parse_str(get_data('php://input', false , null, -1 , $_SERVER['CONTENT_LENGTH'] ), $_PUT): $_PUT=array(); // PHP 5.0
          $data = (!empty($_PUT['data']))?$_PUT['data']:null;
          $sql = 'UPDATE `'.sprintf("%03d",get_data($idLicence, $obj, $bdd)).'` SET data="'.base64_encode($data).'", date_upd = "'.date("Y-m-d H:i:s", time()).'" WHERE id = '.$id.';';
          $bdd->query($sql);
          echo '{"message": "OK"}';
        }else{
          echo '{"message": "ERROR"}';
        }   
        break;
      default:
        echo '{"message": "ERROR"}';
        break;
    }
  }else{
    echo '{"message": "ERROR"}';
  }
//Gestion des erreurs
} catch (Exception $e) {
  die('Erreur :'.$e->getMessage());
}

function get_data($idLicence, $obj, $bdd){
  $sql = 'SELECT data FROM cache_obj WHERE obj="'.$obj.'" AND id_licence='.$idLicence;
  $response = $bdd->query($sql);
  if($response->rowCount()==0){
    return add_obj($idLicence, $obj, $bdd);
  }else{
    $data = $response->fetchAll(PDO::FETCH_ASSOC);
    return $data[0]['data'];
  }
}

function add_obj($idLicence, $obj, $bdd){
  $monfichier = fopen('cpt_obj.txt', 'r+');
 
  $cpt_obj = intval(fgets($monfichier)); // On lit la première ligne (nombre d'objets)
  $cpt_obj += 1; // On augmente de 1 ce nombre
  fseek($monfichier, 0); // On remet le curseur au début du fichier
  fputs($monfichier, $cpt_obj); // On écrit le nouveau nombre de pages vues
  fclose($monfichier);

  $sql = "INSERT INTO cache_obj (id_licence, data, obj, date_add) VALUES (".$idLicence.", ".$cpt_obj.", '".$obj."', '".date("Y-m-d H:i:s", time())."')";
  $bdd->query($sql);
  $bdd->query("CREATE TABLE `".sprintf("%03d", $cpt_obj)."` (id int(11) AUTO_INCREMENT PRIMARY KEY, data varchar(16000) NOT NULL,".
    " date_add datetime NOT NULL, date_upd datetime NOT NULL) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4;");

  return $cpt_obj;
}

//Encode en base 64 URL une string
function base64urlEncode(string $str): string{
  return (str_replace(['+','/','='], ['-','_',''], base64_encode($str)));
}

//Decode une string en base 64 URL
function base64urlDecode(string $str): string{
  return (base64_decode(str_replace(['+','/'], ['-','_'],$str)));
}
 
?>
